/*
 * NET Thermometer client/server
 *
 *  Copyright (C) 1999  Claudio Lanconelli
 *                                                                     
 *  e-mail: lanconel@cs.unibo.it                                      
 *  http://www.cs.unibo.it/~lanconel                              
 */

//-------------------------------------------------------------------------//
//                                                                         //
// This program is free software; you can redistribute it and/or           //
// modify it under the terms of the GNU  General Public License            //
// as published by the Free Software Foundation; either version2 of        //
// the License, or (at your option) any later version.                     //
//                                                                         //
// This program is distributed in the hope that it will be useful,         //
// but WITHOUT ANY WARRANTY; without even the implied warranty of          //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       //
// General Public License for more details.                                //
//                                                                         //
// You should have received a copy of the GNU  General Public License      //
// along with this program (see COPYING);     if not, write to the         //
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. //
//                                                                         //
//-------------------------------------------------------------------------//

#include "../readtemp.h"
#include "inet.h"

void SocketEnd()
{
#ifdef	WIN32
	WSACleanup(); 
#endif
}

int SocketInit()
{
#ifdef	WIN32
	WORD wVersionRequested; 
	WSADATA wsaData; 
	int err; 
	wVersionRequested = MAKEWORD(1, 0); 
 
	err = WSAStartup(wVersionRequested, &wsaData); 
 
	if (err != 0) 
		/* Tell the user that we couldn't find a useable */ 
		/* winsock.dll.     */ 
		return 0; 
 
	/* Confirm that the Windows Sockets DLL supports 1.0.*/ 
	/* Note that if the DLL supports versions greater */ 
	/* than 1.0 in addition to 1.0, it will still return */ 
	/* 1.0 in wVersion since that is the version we */ 
	/* requested. */ 
 
	if ( LOBYTE( wsaData.wVersion ) != 1 || 
			HIBYTE( wsaData.wVersion ) != 0 )
	{ 
		fprintf(stderr, "No usable WinSock DLL\n");
		WSACleanup(); 
		return 0; 
	} 
	/* The Windows Sockets DLL is acceptable. Proceed. */ 
#endif
	return 1;
}

#ifdef	WIN32
static struct {
	int errval;
	char *errstr;
} sockerrors[] = {
	{WSANOTINITIALISED, "A successful WSAStartup must occur before using this function."},
	{WSAENETDOWN,"The Windows Sockets implementation has detected that the network subsystem has failed."},
	{WSAEAFNOSUPPORT,"The specified address family is not supported."},
	{WSAEINPROGRESS,"A blocking Windows Sockets operation is in progress."},
	{WSAEMFILE, "No more file descriptors are available."},
	{WSAENOBUFS, "No buffer space is available. The socket cannot be created."},
	{WSAEPROTONOSUPPORT, "The specified protocol is not supported."},
	{WSAEPROTOTYPE, "The specified protocol is the wrong type for this socket."},
	{WSAESOCKTNOSUPPORT, "The specified socket type is not supported in this address family."},
	{0, NULL}
};

char *GetSockErrorString(int val)
{
	int k;
	for (k = 0; sockerrors[k].errstr != NULL; k++)
	{
		if (sockerrors[k].errval == val)
		{
			break;
		}
	}

	return sockerrors[k].errstr;
}
#endif
